/*********************************************************/
/*  Program testfft.c                                    */
/*     An example of how to use function fft.c           */
/*  Compile by: gcc fftmag.c fft.c -o fft.out -lm       */
/*********************************************************/

#include "complex.h"
#include <math.h>
#include <stdio.h>

extern void fft();

main()
  {
  FILE *fp;
  float ampdb;
  int M = 11;              /* log2(N)                    */
  int N = 1 << M;   /* N = 2**M = Number of FFT points   */
  complex X[N];           /* Declare input array        */
  int i;                   /* loop index                 */
  double pi = 3.141592653589;
/*-------------------------------------------------------*/
/*   Initialize input array                              */
/*  Generate spectral lines at k = 5 and 11 of height 8. */

  if( (fp = fopen("junk.dat","r")) == NULL){
    printf("File doesn't exist! \n");
    exit(1);
  }

  for(i=0; i<N; i++) 
    {
    fscanf(fp,"%*d %lf", &((X[i]).real) );
    (X[i]).imag = 0.0;
    }
/*--------------------------------------------------------*/
/* Apply Hanning window                                   */
  for(i=0; i<N; i++)
   X[i].real = X[i].real * (0.5 - 0.5*cos(2*pi*i/(N-1)) );

/* Perform FFT                                            */

  fft(X,M); 

/*  Display results on screen                             */


  for(i=0; i< N/2 ; i++){
  ampdb  = (X[i].real)*(X[i].real) + (X[i].imag)*(X[i].imag);
  ampdb = 10.0*log10(ampdb);
 printf("%10.6f %15.5f \n", i*7200./N, ampdb);
  }  


}
