$NOFLOATCALLS
C       THIS IS A IIR FILTER DESIGN PROGRAM
C       FOR BUTTERWORTH, CHEBYSHEV, CHEBYSHEV II, & ELLIPTIC
C       FOR LOWPASS, HIGHPASS, BANDPASS, AND BANDREJECT RESPONSES
C       ANALOG AND DIGITAL FILTERS USING THE BLT
C          MAXIMUM PASSBAND RIPPLE AND MINIMUM
C          STOPBAND ATTENUATION ARE IN POSITIVE DB.
C       C. S. BURRUS,    RICE UNIVERSITY,    JAN 25, 1986
C
C  MODIFIED BY S. A. TRETTER, UNIVERSITY OF MARYLAND, COLLEGE PARK
C      NOVEMBER 1986
C------------------------------------------------------------------
        LOGICAL IXST
        DOUBLE PRECISION G
       CHARACTER BELL,LSTNM*50,YN
       DIMENSION PR(40), PI(40), ZR(40), ZI(40)
       DIMENSION B0(40),B1(40),B2(40),A0(40),A1(40),A2(40)
       DIMENSION ZQUE(40),ZFREQ(40),PQUE(40),PFREQ(40)
       DIMENSION FM(601),DB(601),PHASE(601),DELAY(601),FREQ(601)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
       COMMON /ROOT/PR,PI,ZR,ZI
       COMMON /FLIMIT/FSTART,FSTOP
       BELL = CHAR(7)
          TP = 6.283185307179586
C---------INPUT SPECIFICATIONS, PREWARPING, AND PREFREQXFRMING-------
       WRITE(*,'('' SAVE RESULTS IN A FILE (Y OR N): '',\)')
        READ(*,'(A)') YN
        IF(YN.EQ.'Y'.OR.YN.EQ.'y') THEN
800        WRITE(*,'('' ENTER LISTING FILENAME: '',\)')
           READ(*,'(A)') LSTNM
           INQUIRE(FILE=LSTNM,EXIST=IXST)
           IF(IXST) THEN
             WRITE(*,*) BELL 
             WRITE(*,*) '**FILE ALREADY EXISTS. USE ANOTHER NAME.'
             WRITE(*,*) ' '
             GOTO 800
           ENDIF
           OPEN(1,FILE=LSTNM,STATUS='NEW')
        ELSE IF(YN.EQ.'N'.OR.YN.EQ.'n') THEN
           OPEN(1,FILE='CON')
        ENDIF
1006   WRITE(*,'('' ENTER 1 FOR ANALOG, 2 FOR DIGITAL: '',\)')
          READ(*,*) KAD
        IF(KAD.NE.1.AND.KAD.NE.2) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** ENTER 1 OR 2'
          WRITE(*,*) ' '
          GOTO 1006
        ENDIF
        IF(KAD.EQ.2) THEN
1002      WRITE(*,'(1X,A,\)') 'ENTER SAMPLING RATE IN HZ: '
          READ(*,*) SR
          IF(SR.LE.0) THEN
            WRITE(*,*) BELL,BELL
            WRITE(*,*) '**ERROR** SAMPLING RATE MUST BE POSITIVE.'
            WRITE(*,*) ' '
            GOTO 1002
          ENDIF
        ENDIF
1001   WRITE(*,'('' ENTER NUMBER OF FREQS TO DISPLAY: '',\)')
          READ(*,*) KK
       IF(KK.GT.600) THEN
          WRITE(*,*) BELL,BELL
         WRITE(*,*) '**ERROR** NUMBER OF FREQUENCIES CANNOT EXCEED 600.'
          WRITE(*,*) ' '
          GOTO 1001
       ENDIF
      IF(KK.GT.0) THEN
1003    WRITE(*,'(1X,A,\)') 'ENTER STARTING FREQUENCY IN HZ: '
        READ(*,*) FSTART
1004    WRITE(*,'(1X,A,\)') 'ENTER STOPPING FREQUENCY IN HZ: '
        READ(*,*) FSTOP
        IF(FSTART.LT.0) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** STARTING FREQUENCY MUST BE POSITIVE.'
          WRITE(*,*) ' '
          GOTO 1003
        ENDIF
        IF(FSTOP.LE.FSTART) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** FSTOP LESS THAN FSTART.'
          WRITE(*,*) ' '
          GOTO 1004
        ENDIF
        IF(KAD.EQ.2.AND.FSTOP.GT.0.5*SR) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** FSTOP MUST BE LESS THAN FSAMPLE/2'
          WRITE(*,*) ' '
          GOTO 1004
        ENDIF
      ENDIF
 10   WRITE(*,'('' ENTER 1 FOR BW, 2 FOR CHEBY, 3 FOR ICHEBY, 4 FOR ELLI
     1PTIC: '',\)')
          READ(*,*) KA
        IF(KA.LT.1.OR.KA.GT.4) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** ENTER 1, 2, 3, OR 4.'
          WRITE(*,*) ' '
          GOTO 10
        ENDIF
1007  WRITE(*,'('' ENTER 1 FOR LOWPASS, 2 FOR HP, 3 FOR BP, OR 4 FOR BR:
     1 '',\)')
          READ(*,*) KF
        IF(KF.LT.1.OR.KF.GT.4) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** ENTER 1, 2, 3, OR 4.'
          WRITE(*,*) ' '
          GOTO 1007
        ENDIF
 12    IF (KA.EQ.4) GOTO 20
C
C**********************************************************************
C  BUTTERWORTH, CHEBYSHEV, OR ICHEBYSHEV FILTERS
C       USER SUPPLIED ORDER
C
1005    WRITE(*,'(1X,A,\)') 'USER SUPPLIED OR PROGRAM COMPUTED FILTER OR
     1DER (U OR P)? '
        READ(*,'(A)') YN
        IF(YN.NE.'U'.AND.YN.NE.'u'.AND.YN.NE.'P'.AND.YN.NE.'p') THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** ENTER U OR P'
          WRITE(*,*) ' '
          GOTO 1005
        ENDIF
        IF(YN.EQ.'U'.OR.YN.EQ.'u') GO TO 1000
        IF(YN.EQ.'P'.OR.YN.EQ.'p') GO TO 20
1000   WRITE(*,'('' ENTER THE ORDER:  '',\)')
          READ(*,*) N
       IF(N.GT.20) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** ORDER CANNOT EXCEED 20.'
          WRITE(*,*) ' '
          GOTO 1000
       ENDIF
       IF (KF.GE.3) GOTO 15
C----LP OR HP FILTERS--------------------------------------------------
       WRITE(*,'('' ENTER THE PASSBAND EDGE IN HZ: '',\)')
          READ(*,*) FP
          WP = PREWRP(TP*FP)
          IF (KF.EQ.2) WP = 1.0/WP
          IF (KA.EQ.1) GOTO 30
        WRITE(*,'(1X,A,\)') 'ENTER STOPBAND EDGE IN HZ: '
        READ(*,*) FS
        WS = PREWRP(TP*FS)
        IF(KF.EQ.2) WS = 1./WS
        IF(KA.EQ.2) THEN
      WRITE(*,'('' ENTER PASSBAND RIPPLE IN POSITIVE DB: '',\)')
        ELSE IF(KA.EQ.3) THEN
      WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND EDGE IN +DB: '
        ENDIF
          READ(*,*) R1
          GOTO 30
C-----BP OR BR FILTERS-------------------------------------------------
 15    WRITE(*,'('' ENTER F1,F2,F3,F4 FOR BP OR BR FREQS: '',\)')
          READ(*,*) F1,F2,F3,F4
          W1 = PREWRP(TP*F1)
          W2 = PREWRP(TP*F2)
          W3 = PREWRP(TP*F3)
          W4 = PREWRP(TP*F4)
          W0 = SQRT(W3*W2)
          WP = (W3*W3-W0*W0)/W3
          WS = (W4*W4-W0*W0)/W4
          WST= (W0*W0-W1*W1)/W1
          IF (WST.LT.WS) WS = WST
          IF (KF.EQ.3) GOTO 266
             W0 = SQRT(W1*W4)
             WP = W1/(W0*W0-W1*W1)
             WS = W2/(W0*W0-W2*W2)
             WST= W3/(W3*W3-W0*W0)
             IF (WST.LT.WS) WS = WST
266     IF(KA.EQ.1) THEN
      WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND EDGES IN +DB: '
        ELSE IF(KA.EQ.2) THEN
          WRITE(*,'(1X,A,\)') 'ENTER PASSBAND RIPPLE IN +DB: '
        ELSE IF(KA.EQ.3) THEN
      WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND EDGES IN +DB: '
        ENDIF
          READ(*,*) R1
          GOTO 30
C
C**********************************************************************
C  BUTTERWORTH, CHEBYSHEV, ICHEBYSHEV WITH PROGRAM COMPUTED ORDER
C   AND ALL ELLIPTIC FILTERS
C
C-----LP OR HP FILTERS-------------------------------------------------
 20    IF (KF.GE.3) GOTO 25
 300   WRITE(*,'('' ENTER PASS AND STOPBAND EDGES IN HZ: '',\)')
          READ(*,*) FP,FS
        IF((KF.EQ.2).AND.(FP.LT.FS)) THEN
          WRITE(*,*) BELL,BELL
          WRITE(*,*) '**ERROR** PASSBAND EDGE MUST BE GREATER THAN STOPB 
     1AND EDGE.'
          WRITE(*,*) '          BE SURE TO ENTER PASSBAND EDGE FIRST.'
          WRITE(*,*) ' '
          GOTO 300
        ENDIF
          WP = PREWRP(TP*FP)
          WS = PREWRP(TP*FS)
          IF (KF.EQ.2) WP = 1.0/WP
          IF (KF.EQ.2) WS = 1.0/WS
        IF(KA.EQ.1) THEN
          WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND AND STOPBAN
     1D EDGES IN +DB: '
        ELSE IF(KA.EQ.2) THEN
          WRITE(*,'(1X,A,\)') 'ENTER PASSBAND RIPPLE AND ATTENUATION AT 
     1STOPBAND EDGE IN +DB: '
        ELSE IF(KA.EQ.3) THEN
          WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND EDGE AND ST
     1OPBAND ATTENUATION IN +DB: '
        ELSE IF(KA.EQ.4) THEN
      WRITE(*,'('' ENTER PASSBAND RIPPLE AND STOPBAND ATTENUATION IN +DB
     1: '',\)')
        ENDIF
          READ(*,*) R1,R2
        IF(KA.LE.3) GOTO 30
        IF(KA.EQ.4) GOTO 35
C-----BP OR BR FILTERS-------------------------------------------------
 25    WRITE(*,'('' ENTER F1,F2,F3,F4 FOR BP OR BR FREQS: '',\)')
          READ(*,*) F1,F2,F3,F4
          W1 = PREWRP(TP*F1)
          W2 = PREWRP(TP*F2)
          W3 = PREWRP(TP*F3)
          W4 = PREWRP(TP*F4)
          W0 = SQRT(W3*W2)
          WP = (W3*W3-W0*W0)/W3
          WS = (W4*W4-W0*W0)/W4
          WST= (W0*W0-W1*W1)/W1
          IF (WST.LT.WS) WS = WST
          IF (KF.EQ.3) GOTO 26
             W0 = SQRT(W1*W4)
             WP = W1/(W0*W0-W1*W1)
             WS = W2/(W0*W0-W2*W2)
             WST= W3/(W3*W3-W0*W0)
             IF (WST.LT.WS) WS = WST
26      IF(KA.EQ.1) THEN
          WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND AND STOPBAN
     1D EDGES IN +DB: '
        ELSE IF(KA.EQ.2) THEN
          WRITE(*,'(1X,A,\)') 'ENTER PASSBAND RIPPLE AND ATTENUATION AT 
     1STOPBAND EDGE IN +DB: '
        ELSE IF(KA.EQ.3) THEN
          WRITE(*,'(1X,A,\)') 'ENTER ATTENUATION AT PASSBAND EDGE AND ST
     1OPBAND ATTENUATION IN +DB: '
        ELSE IF(KA.EQ.4) THEN
       WRITE(*,'('' ENTER PASSBAND RIPPLE AND STOPBAND ATTENUATION IN + 
     1DB: '',\)')
        ENDIF
        READ(*,*) R1,R2
        IF(KA.LE.3) GOTO 30
        IF(KA.EQ.4) GOTO 35
C-------------BUTTERWORTH, CHEBYSHEV, AND ELLIPTIC FILTERS--
 30    CALL ROOTS1(YN)
       GO TO 37
 35    CALL ROOTS2
C---------HIGHPASS, BANDPASS, AND BAND REJECT XFORMS--------
 37    IF (KF.EQ.1) GOTO 65
       CALL FREQXFM(W0,PR,PI)
       CALL FREQXFM(W0,ZR,ZI)
       IF (KF.EQ.2) GOTO 65
C  DOUBLE ORDER FOR BP AND BR FILTERS
          N2 = N
          N  = 2*N
          KOD = 0
C
C**********************************************************************
C  PROCESS DIGITAL FILTERS
C
 65    IF (KAD.EQ.2) THEN
C-------------DIGITAL BILINEAR XFORM------------------------
       CALL BLT(N2,SR,PR,PI)
       CALL BLT(N2,SR,ZR,ZI)
          CALL PRNT(PR,PI,ZR,ZI)
C-------------CASCADE STRUCTURE AND FREQUENCY RESPONSE------
 80    CALL CASCAD(PR,PI,ZR,ZI,B0,B1,B2,A0,A1,A2,G)
       KFLAG=1
       CALL DFR(KK,B1,B2,A1,A2,FM,DB,PHASE,DELAY,G,KFLAG,W0)
       WRITE(1,*) ' '
       WRITE(1,*) '  SCALE FACTOR FOR UNITY GAIN IN PASSBAND: ',G
       KFLAG = 2
       CALL DFR(KK,B1,B2,A1,A2,FM,DB,PHASE,DELAY,G,KFLAG,W0)
       ENDIF
C
C**********************************************************************
C  PROCESS ANALOG FILTER
C
       IF (KAD.EQ.1) THEN
          CALL PRNT(PR,PI,ZR,ZI)
          CALL CASCAD(PR,PI,ZR,ZI,B0,B1,B2,A0,A1,A2,G)
          KFLAG = 1
       CALL AFR(KK,B0,B1,B2,A0,A1,A2,FM,DB,PHASE,DELAY,G,KFLAG,W0)
          WRITE(1,*) ' '
          WRITE(1,*) 'SCALE FACTOR FOR UNITY GAIN IN PASSBAND: ',G
          KFLAG = 2
       CALL AFR(KK,B0,B1,B2,A0,A1,A2,FM,DB,PHASE,DELAY,G,KFLAG,W0)
       ENDIF
C**********************************************************************
       IF(KK.NE.0) CALL VIEW(SR,KK,FM,DB,PHASE,DELAY,FREQ)
       END
C-------------END OF MAIN PROGRAM-------------------------
C-------------BW, CHEBY I&II POLE & ZERO LOCATIONS--------
       SUBROUTINE ROOTS1(YN)
       CHARACTER YN
       DIMENSION PR(40),PI(40),ZR(40),ZI(40)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
       COMMON /ROOT/PR,PI,ZR,ZI
       ARCSNH(X) = ALOG(X+SQRT(X*X+1))
       ARCCSH(X) = ALOG(X+SQRT(X*X-1))
C
       E = SQRT(10.0**(0.1*R1) - 1)
       IF(KA.EQ.1.AND.(YN.EQ.'P'.OR.YN.EQ.'p')) THEN
          AP = 10.**(0.1*R1)
          AS = 10.**(0.1*R2)
          FLN = 0.5*ALOG((AP-1.)/(AS-1.))/ALOG(WP/WS)
          N = INT(FLN)
          IF(FLN.GT.N) N = N+1
          WP = WP/(AP - 1.)**(0.5/FLOAT(N))
       ELSE IF(KA.EQ.2.AND.(YN.EQ.'P'.OR.YN.EQ.'p')) THEN
          AS = 10.**(0.1*R2)
          FLN = ARCCSH(SQRT(AS-1.)/E)/ARCCSH(WS/WP)
          N = INT(FLN)
          IF(FLN.GT.N) N = N+1
       ELSE IF(KA.EQ.3.AND.(YN.EQ.'P'.OR.YN.EQ.'p')) THEN
          AS = 10.**(0.1*R2)
          FLN = ARCCSH(SQRT(AS-1.)/E)/ARCCSH(WS/WP)
          N = INT(FLN)
          IF(FLN.GT.N) N = N+1
       ENDIF
       IF(YN.EQ.'P'.OR.YN.EQ.'p') THEN
        WRITE(*,*) ' '
        WRITE(*,*) 'COMPUTED PROTOTYPE LOWPASS FILTER ORDER = ',N
       ENDIF
       N2 = (N+1)/2
       L  = 0
       KOD = 1
       IF (MOD(N,2).EQ.0) KOD = 0
       IF (KOD.EQ.0) L = 1
          SM = 1.0
          CM = 1.0
       IF(KA.EQ.1) GOTO 10
      IF(KA.EQ.2) THEN
        V0 = ARCSNH(1/E)/N
      ELSE IF(KA.EQ.3) THEN
        V0 = ARCSNH(E*COSH(N*ARCCSH(WS/WP)))/N
      ENDIF
       SM = SINH(V0)
       CM = COSH(V0)
 10    DO 15 J = 1, N2
          ARG = 1.570796326794897*L/N
          TR = -SM*COS(ARG)
          TI =  CM*SIN(ARG)
          ZR(J) = 0.0
          ZI(J) = 1E25
          IF (KA.EQ.3) GOTO 11
             PR(J) = WP*TR
             PI(J) = WP*TI
          GO TO 12
 11          IF (L.NE.0) ZI(J) = WS/SIN(ARG)
             PR(J) = WS*TR/(TR*TR + TI*TI)
             PI(J) = WS*TI/(TR*TR + TI*TI)
 12       L = L + 2
 15    CONTINUE
       RETURN
       END
C-----------ELLIPTIC FILTER POLE & ZERO LOCATIONS------
       SUBROUTINE ROOTS2
       REAL K, KC, KK, KKC, K1, K1C, KK1, KK1C
       DIMENSION PR(40),PI(40),ZR(40),ZI(40)
       COMMON /ROOT/PR,PI,ZR,ZI
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
       COMMON /ELP1/SN,CN,DN
C
       E = SQRT(10.0**(0.1*R1)-1)
          K   = WP/WS
          KC  = SQRT(1-K*K)
          K1  = E/SQRT(10.**(0.1*R2)-1)
          K1C = SQRT(1-K1*K1)
          KK  = CEI(KC)
          KKC = CEI(K)
          KK1 = CEI(K1C)
          KK1C= CEI(K1)
          XN  = KK*KK1C/KK1/KKC
          N   = INT(XN + 1.0)
          WRITE(*,*) ' '
             WRITE(*,*) 'ELLIPTIC FILTER ORDER = ',N
          K1  = FK(N*KKC/KK)
          K1C = SQRT(1-K1*K1)
          KK1 = CEI(K1C)
       L  = 0
       N2 = (N+1)/2
       KOD = 1
          IF(MOD(N,2).EQ.0) KOD = 0
          IF(KOD.EQ.0) L = 1
       V0 = (KK/KK1/N)*ARCSC(1/E,K1)
       CALL ELP(V0,K)
       SM = SN
       CM = CN
       DM = DN
       ZI(1) = 1E25
       DO 15 J = 1, N2
          ARG = KK*L/N
          CALL ELP(ARG,KC)
          ZR(J) = 0.0
          IF (L.NE.0) ZI(J) =  WS/SN
          PR(J) = -WP*SM*CM*CN*DN/(1-((DN*SM)**2.0))
          PI(J) =  WP*DM*SN/(1-((DN*SM)**2.0))
          L = L + 2
 15    CONTINUE
       RETURN
       END
C----------PREWARP OF FREQS BEFORE BLT--------------------
       FUNCTION PREWRP(WW)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
          IF (KAD.EQ.1) PREWRP = WW
          IF (KAD.NE.1) PREWRP = 2.0*SR*TAN(WW/2.0/SR)
       RETURN
       END
C----------DIGITAL BILINEAR TRANSFORMATION----------------
       SUBROUTINE BLT(N2,SR,R,I)
       REAL SR, R(1), I(1)
C
       A = 2.0*SR
       DO 15 J=1, N2+1
          TR = R(J)
          TI = I(J)
             IF (ABS(TI).GT.1E15) GOTO 10
             IF (ABS(TR).GT.1E15) GOTO 10
          TD = (A - TR)**2 + TI*TI
          R(J) = (A*A - TR*TR - TI*TI)/TD
          I(J) = 2.0*A*TI/TD
          GOTO 15
 10          R(J) = -1.0
             I(J) =  0.0
 15    CONTINUE
       RETURN
       END
C-------------FREQUENCY TRANSFORMATION--------------------
       SUBROUTINE FREQXFM(W0,PR,PI)
       REAL PR(1), PI(1)
       COMPLEX PC, SC
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
C
       NT = 2*N2+1
       IF (KF.GE.3) GOTO 12
C-----HP FILTER--------------------------------------------------------
  5    DO 10 J=1, N2
          IF (PI(J).GT.1E15) GOTO 7
          PC = CMPLX (PR(J), PI(J))
          SC = 1.0/PC
          PR(J) = -ABS(REAL(SC))
          PI(J) =  ABS(AIMAG(SC))
          GOTO 10
  7         PR(J) = 0.0
            PI(J) = 0.0
 10    CONTINUE
       RETURN
C-----BP OR BR FILTERS-------------------------------------------------
 12    DO 14 J=1, N2
            IF (PI(J).GT.1E15) GOTO 13
          PC = CMPLX (PR(J), PI(J))
            IF (KF.EQ.4) PC = 1.0/PC
          SC = (PC - CSQRT(PC*PC-4*W0*W0))/2.0
          PR(J) = -ABS(REAL(SC))
          PI(J) =  ABS(AIMAG(SC))
          SC = (PC + CSQRT(PC*PC-4*W0*W0))/2.0
          PR(NT-J) = -ABS(REAL(SC))
          PI(NT-J) =  ABS(AIMAG(SC))
          GOTO 14
 13         PR(J) = 0.0
            PR(NT-J) = 0.0
            PI(J) = 1E17
            PI(NT-J) = 0.0
            IF (KF.EQ.4) PI(J) = W0
            IF (KF.EQ.4) PI(NT-J) = W0
 14    CONTINUE
       RETURN
       END
C-----------COMPLETE ELLIPTIC INTEGRAL---------------
       FUNCTION CEI(KC)
       REAL KC
C
       A = 1.0
       B = KC
       DO 10 J = 1, 20
          AT = (A+B)/2
          B  = SQRT(A*B)
          A  = AT
          IF((A-B)/A .LT. 1.2E-7) GO TO 15
 10    CONTINUE
       WRITE(*,*) 'CEI FAILED TO CONVERGE'
 15    CEI = 1.570796326794896/A
       RETURN
       END
C-------------ELLIPTIC FUNCTIONS------------------
       SUBROUTINE ELP(X,KC)
       REAL KC
       DIMENSION AA(16),BB(16)
       COMMON /ELP1/SN,CN,DN
C
       IF (X.EQ.0) GOTO 20
       I = 1
       A = 1.0
       B = KC
 4     CONTINUE
           AA(I) = A
           BB(I) = B
           AT = (A+B)/2
           B  = SQRT(A*B)
           A  = AT
           IF(((A-B)/A) .LT. 1.3E-7) GO TO 15
           IF (I.GT.15) GOTO 10
           I = I + 1
       GOTO 4
 10    WRITE(*,*) 'ELP FAILED TO CONVERGE'
 15    C = A/TAN(X*A)
       D = 1.0
 16    CONTINUE
           E = C*C/A
           C = C*D
           A = AA(I)
           D = (E+BB(I))/(E+A)
           I = I-1
       IF(I.NE.0) GO TO 16
       SN = 1/SQRT(1+C*C)
       CN = SN*C
       DN = D
       RETURN
 20        SN = 0.0
           CN = 1.0
           DN = 1.0
       RETURN
       END
C---------------ARC ELLIPTIC TANGENT---------------
       FUNCTION ARCSC(U,KC)     
       REAL KC
        A = 1.0
        B = KC
        Y = 1.0/U
        L = 0
        DO 10 J = 1, 15
           BT = A*B
           A  = A + B
           B = 2.0*SQRT(BT)
           Y  = Y - BT/Y
             IF (Y.EQ.0) Y = SQRT(BT)*1E-10
           IF (ABS(A-B).LT.(A*1.2E-7)) GOTO 15
           L = 2*L
           IF (Y.LT.0) L = L + 1
 10     CONTINUE
        WRITE(*,*) 'ARCSC FAILED TO CONVERGE'
 15     IF (Y.LT.0) L = L + 1
        ARCSC = (ATAN(A/Y) + 3.141592654*L)/A
        RETURN
        END
C--------------MODULUS FROM RATIO OF K/K'---------------
        FUNCTION FK(U)
C
        Q = EXP(-3.141592654*U)
        A = 1.0
        B = 1.0
        C = 1.0
        D = Q
        DO 10 J = 1, 15
           A = A + 2*C*D
           C = C*D*D
           B = B + C
           D = D*Q
           IF (C.LT.1E-7) GOTO 15
 10     CONTINUE
        WRITE(*,*) 'FK FAILED TO CONVERGE'
 15     FK = 4*SQRT(Q)*(B/A)**2
        RETURN
        END
C----------------PRINT---------------------------------
       SUBROUTINE PRNT(PR,PI,ZR,ZI)
       DIMENSION PR(40),PI(40),ZR(40),ZI(40)
       DIMENSION ZQUE(40),ZFREQ(40),PQUE(40),PFREQ(40)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
        TP = 6.2831853071
        IF(KAD.EQ.1) WRITE(1,'(20X,A,\)') 'ANALOG'
        IF(KAD.EQ.2) WRITE(1,'(20X,A,\)') 'DIGITAL'
        IF(KF.EQ.1) WRITE(1,'(1X,A,\)') 'LOWPASS'
        IF(KF.EQ.2) WRITE(1,'(1X,A,\)') 'HIGHPASS'
        IF(KF.EQ.3) WRITE(1,'(1X,A,\)') 'BANDPASS'
        IF(KF.EQ.4) WRITE(1,'(1X,A,\)') 'BANDSTOP'
        IF(KA.EQ.1) WRITE(1,'(1X,A)') 'BUTTERWORTH FILTER'
        IF(KA.EQ.2) WRITE(1,'(1X,A)') 'CHEBYSHEV FILTER'
        IF(KA.EQ.3) WRITE(1,'(1X,A)') 'INVERSE CHEBYSHEV FILTER'
        IF(KA.EQ.4) WRITE(1,'(1X,A)') 'ELLIPTIC FILTER'
        WRITE(1,*) ' '
        WRITE(1,'(25X,''FILTER ORDER = '',I2)') N
C
C  DISPLAY DIGITAL FILTER ZEROS AND POLES
C
       IF(KAD.EQ.2) THEN
        WRITE(1,*) ' '
        WRITE(1,'(25X,'' Z PLANE'')')
        WRITE(1,*) ' '
       WRITE(1,*) '          ZEROS                         POLES'
       WRITE(1,*) ' '
       NN = 1
       IF(KOD.EQ.1) THEN
          NN = 2
          WRITE(1,1001) ZR(1),PR(1)
 1001      FORMAT('   ',4X,F9.6,5X,9X,4X,F9.6)
       ENDIF
       DO 1 I=NN,N2
 1        WRITE (1,10) ZR(I),ZI(I),PR(I),PI(I)
  10    FORMAT ('   ',4X,F9.6,' +- j',F9.6,4X,F9.6,' +- j',F9.6)
        WRITE(1,*) ' '
        WRITE(1,1007)
1007    FORMAT(7X,'  RADIUS',T24,'FREQUENCY',T40,'  RADIUS',T56,'FREQUEN
     1CY')
        WRITE(1,*) ' '
        NN = 1
        IF(KOD.EQ.1) THEN
          NN = 2
          ZQUE(1) = ABS(ZR(1))
          ZFREQ(1) = 0
          IF(ZR(1).LT.0) ZFREQ(1) = SR/2.
          PQUE(1) = ABS(PR(1))
          PFREQ(1) = 0
          IF(PR(1).LT.0) PFREQ(1) = SR/2.
          WRITE(1,1008) ZQUE(1),ZFREQ(1),PQUE(1),PFREQ(1)
1008      FORMAT(2X,4(4X,E12.6))
        ENDIF
        DO 1009 I = NN,N2
          ZQUE(I) = SQRT(ZR(I)**2 + ZI(I)**2)
          ZR1 = ZR(I)
          IF(ZR1.EQ.0) ZR1 = 1.E-25
          ZFREQ(I) = SR*ATAN2(ZI(I),ZR1)/TP
          PQUE(I) = SQRT(PR(I)**2 + PI(I)**2)
          PR1 = PR(I)
          IF(PR1.EQ.0) PR1 = 1.E-25
          PFREQ(I) = SR*ATAN2(PI(I),PR1)/TP
1009      WRITE(1,1008) ZQUE(I),ZFREQ(I),PQUE(I),PFREQ(I)
        ENDIF
C 
C  DISPLAY ANALOG FILTER ZEROS AND POLES
C
        IF(KAD.EQ.1) THEN
        WRITE(1,*) ' '
        WRITE(1,'(26X,A)') 's PLANE'
        WRITE(1,*) ' '
      WRITE(1,*)'             ZEROS                               POLES'
           WRITE(1,*) ' '
        NN = 1
        K = 0
        IF(MOD(N2,2).NE.0.AND.KF.EQ.3) K = 1
        IF(KOD.EQ.1) THEN
          NN = 2
          IF(ZR(1).GT.1E15.OR.ZI(1).GT.1E15) THEN
            WRITE(1,1002) PR(1)
1002        FORMAT(7X,12X,5X,12X,4X,E12.6)
          ELSE
            WRITE(1,1003) ZR(1),PR(1)
1003        FORMAT(7X,E12.6,5X,12X,4X,E12.6)
          ENDIF
        ENDIF
        DO 2 I=NN,N2
          IF(I.EQ.1.AND.K.EQ.1) THEN
            ZR1=0
            WRITE(1,1006) ZR1,PR(I),PI(I)
1006        FORMAT(7X,E12.6,5X,12X,4X,E12.6,' +- j',E12.6)
          ENDIF
          IF(K.NE.1.OR.I.GT.1) THEN
            IF(ZI(I).GT.1E15) THEN
              WRITE(1,1004) PR(I),PI(I)
1004          FORMAT(7X,12X,5X,12X,4X,E12.6,' +- j',E12.6)
            ELSE 
              WRITE(1,1005) ZR(I),ZI(I),PR(I),PI(I)
1005          FORMAT(7X,E12.6,' +- j',E12.6,4X,E12.6,' +- j',E12.6)
            ENDIF
          ENDIF
2       CONTINUE
C----- DISPLAY Q'S AND FREQUENCIES ------------------------------------
        WRITE(1,*) ' '
        WRITE(1,1010)
1010  FORMAT(7X,'    Q',T24,'  FREQUENCY',T40,'    Q',T56,'  FREQUENCY')
        WRITE(1,*) ' '
        NN = 1
        IF(KOD.EQ.1) THEN
          NN = 2
          ZQUE(1) = 0
          PQUE(1) = 0
          IF(ZI(1).GT.1.E15) THEN
            ZFREQ(1) = 1.E25
            PFREQ(1) = PR(1)/TP
            WRITE(1,1011) PFREQ(1)
1011        FORMAT(6X,12X,4X,12X,4X,12X,4X,E12.6)
          ELSE IF(ZR(1).EQ.0.AND.ZI(1).EQ.0) THEN
            ZFREQ(1) = 0
            PFREQ(1) = PR(1)/TP
            WRITE(1,1011) PFREQ(1)
          ELSE
            ZFREQ(1) = ZR(1)/TP
            PFREQ(1) = PR(1)/TP
            WRITE(1,1012) ZFREQ(1),PFREQ(1)
1012        FORMAT(6X,12X,4X,E12.6,4X,12X,4X,E12.6)
          ENDIF
        ENDIF
        DO 3 I=NN,N2
        PFREQ(I) = SQRT(PR(I)**2 + PI(I)**2)
        PQUE(I) = -0.5*PFREQ(I)/PR(I)
        PFREQ(I) = PFREQ(I)/TP
        IF(I.EQ.1.AND.K.EQ.1) THEN
          ZQUE(I) = 0
          ZFREQ(I) = 0
          WRITE(1,1013) PQUE(I), PFREQ(I)
1013      FORMAT(6X,12X,4X,12X,4X,E12.6,4X,E12.6)
        ENDIF
        IF(K.NE.1.OR.I.GT.1) THEN
          IF(ZI(I).GT.1E15) THEN
            ZQUE(I) = 0
            ZFREQ(I) = 1.E25
            WRITE(1,1013) PQUE(I),PFREQ(I)
          ELSE IF(ZR(I).EQ.0.AND.ZI(I).EQ.0) THEN
            ZQUE(I) = 0
            ZFREQ(I) = 0
            WRITE(1,1013) PQUE(I),PFREQ(I)
          ELSE
            ZFREQ(I) = SQRT(ZR(I)**2 + ZI(I)**2)
            IF(ZR(I).EQ.0) ZQUE(I) = 1.E25
            IF(ZR(I).NE.0) ZQUE(I) = -0.5*ZFREQ(I)/ZR(I)
            ZFREQ(I) = ZFREQ(I)/TP
            WRITE(1,1008) ZQUE(I),ZFREQ(I),PQUE(I),PFREQ(I)
          ENDIF
        ENDIF
3       CONTINUE
        ENDIF
        WRITE(*,*) ' '
        RETURN
        END
C-----------CASCADE STRUCTURE PARAMETERS--------------
       SUBROUTINE CASCAD(PR,PI,ZR,ZI,B0,B1,B2,A0,A1,A2,G)
        DOUBLE PRECISION G
       DIMENSION PR(1),PI(1),ZR(1),ZI(1)
       DIMENSION B0(20),B1(20),B2(20),A0(20),A1(20),A2(20)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
C
       WRITE(1,*)
       WRITE(1,*)  N2,' CASCADE STAGES, EACH OF THE FORM:'
       IF(KAD.EQ.2) THEN
        WRITE(1,*)
       WRITE(1,*) 'F(z) = ( 1 + B1*z**(-1) + B2*z**(-2) ) / ( 1 + A1*z**
     1(-1) + A2*z**(-2) )'
        WRITE(1,*) ' '
      WRITE(1,*)'        B1           B2               A1           A2'
       ELSE IF(KAD.EQ.1) THEN
       WRITE(1,*) ' '
       WRITE(1,*) 'F(s) = (B0*s**2 + B1*s + B2)/(A0*s**2 + A1*s + A2)'
       WRITE(1,*) ' '
      WRITE(1,*)'  B0      B1           B2            A0       A1       
     1    A2'
       ENDIF
C
C**********************************************************************
C  PROCESS DIGITAL FILTERS
          IF(KAD.EQ.1) GOTO 99
       K = 0
       IF ((MOD(N2,2).NE.0).AND.(KF.EQ.3)) K = 1
       J0 = 1
       IF (KOD.EQ.0) GOTO 10
          B1(1) =  1.0
          IF (KF.EQ.2) B1(1) = -1.0
          B2(1) =  0.0
          A1(1) = -PR(1)
          A2(1) =  0.0
          WRITE (1,30) B1(J0), B2(J0), A1(J0), A2(J0)
          J0 = 2
 10    DO 15 J = J0, N2
          B1(J) = -2.0*ZR(J)
          B2(J) =  ZR(J)*ZR(J) + ZI(J)*ZI(J)
            IF ((J.EQ.1).AND.(K.EQ.1)) B1(J) = 0.0
            IF ((J.EQ.1).AND.(K.EQ.1)) B2(J) = -1.0
          A1(J) = -2.0*PR(J)
          A2(J) =  PR(J)*PR(J) + PI(J)*PI(J)
            IF (PI(J).EQ.0) A1(1) = -PR(1)-PR(N2+1)
            IF (PI(J).EQ.0) A2(1) =  PR(1)*PR(N2+1)
          WRITE (1,30) B1(J), B2(J), A1(J), A2(J)
 15    CONTINUE
       RETURN
 30    FORMAT (' ',2F13.6,'     ',2F13.6)
C
C**********************************************************************
C  PROCESS ANALOG FILTERS
99      K = 0
        IF(MOD(N2,2).NE.0.AND.KF.EQ.3) K = 1
        J0 = 1
        IF(KOD.EQ.0) GOTO 110
        B0(1) = 0
        B1(1) = 0
        IF(KF.EQ.2) B1(1) = 1
        B2(1) = 1.
        IF(KF.EQ.2) B2(1) = 0
        A0(1) = 0
        A1(1) = 1.
        A2(1) = -PR(1)
        WRITE(1,130) B0(1),B1(1),B2(1),A0(1),A1(1),A2(1)
        J0 = 2
110     DO 115 J=J0,N2
        IF(ZI(J).LT.1E15) THEN
          B0(J) = 1.
          B1(J) = -2.*ZR(J)
          B2(J) = ZR(J)**2 + ZI(J)**2
        ELSE IF(ZI(J).GE.1E15) THEN
          B0(J) = 0
          B1(J) = 0
          B2(J) = 1.
        ENDIF
        IF(J.EQ.1.AND.K.EQ.1) THEN
          B0(J) = 0
          B1(J) = 1.
          B2(J) = 0.
        ENDIF
        A0(J) = 1.
        A1(J) = -2.*PR(J)
        A2(J) = PR(J)**2 + PI(J)**2
        IF(PI(J).EQ.0) THEN
          A1(1) = -PR(1)-PR(N2-1)
          A2(1) = PR(1)*PR(N2+1)
        ENDIF
        WRITE(1,130) B0(J),B1(J),B2(J),A0(J),A1(J),A2(J)
115     CONTINUE
130     FORMAT(1X,F6.2,2E13.6,3X,F6.2,2E13.6)
        RETURN
       END
C-------------ANALOG FILTER FREQ RESPONSE---------------------
      SUBROUTINE AFR(KK,B0,B1,B2,A0,A1,A2,FM,DB,PHASE,DELAY,G,KFLAG,W0)
       DOUBLE PRECISION BMAG2,BRT,BIT,AMAG2,ART,AIT,G
       DOUBLE PRECISION BRS,ARS,BR,BI,AR,AI,FNUMER,DENOM
       DIMENSION B0(1),B1(1),B2(1),A0(1),A1(1),A2(1)
       DIMENSION FM(1),DB(1),PHASE(1),DELAY(1)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
       COMMON /FLIMIT/FSTART,FSTOP
       TWOPI = 6.283185307179
C
        IF(KFLAG.EQ.1) THEN
           IF(KF.EQ.1) Q = 0
           IF(KF.EQ.2) Q = 1.E10
           IF(KF.EQ.3) Q = W0
           IF(KF.EQ.4) Q = 0
           LL = 1
        ENDIF
        IF(KFLAG.EQ.2) THEN
           IF(KK.EQ.0) RETURN
           Q = TWOPI*FSTART
           DQ = TWOPI*(FSTOP - FSTART)/FLOAT(KK)
           LL = KK + 1
        ENDIF
       DO 20 J = 1, LL
          W  = Q + DQ*(J-1)
          IF(KFLAG.EQ.1) W=Q
          W2 = W**2
          BR = 1.0
          BI = 0.0
          BDELAY = 0
          AR = 1.0
          AI = 0.0
          ADELAY = 0
          DO 15 I = 1, N2
             BRT = B2(I) - B0(I)*W2
             BIT = B1(I)*W
             DBRT = -2.*B0(I)*W
             DBIT = B1(I)
             ART = A2(I) - A0(I)*W2
             AIT = A1(I)*W
             DART = -2.*A0(I)*W
             DAIT = A1(I)
             BMAG2 = BRT**2 + BIT**2
             IF(BMAG2.EQ.0) BMAG2 = 1.E-25
             BDELAY = BDELAY + (BIT*DBRT - BRT*DBIT)/BMAG2
             AMAG2 = ART**2 + AIT**2
             IF(AMAG2.EQ.0) AMAG2 = 1.E-25
             ADELAY = ADELAY + (AIT*DART - ART*DAIT)/AMAG2
             BRS = BR*BRT - BI*BIT
             BI  = BR*BIT + BI*BRT
             BR  = BRS
             ARS = AR*ART - AI*AIT
             AI  = AR*AIT + AI*ART
             AR  = ARS
 15       CONTINUE
          FM(J) = SQRT((BR*BR + BI*BI)/(AR*AR + AI*AI))
          IF(KFLAG.EQ.1) G = 1./FM(1)
          IF(KFLAG.EQ.2) THEN
             FM(J) = G*FM(J)
             DENOM = AR*BR + AI*BI
             IF(ABS(DENOM).LT.1.E-25) THEN
                TDENOM = DENOM
                DENOM = 1.E-25
                IF(TDENOM.LT.0) DENOM = - DENOM
             ENDIF
             FNUMER = AR*BI - AI*BR
             PHASE(J) = ATAN2(FNUMER,DENOM)
             DELAY(J) = BDELAY - ADELAY
          ENDIF
          IF(FM(J).LT.1.E-25) FM(J) = 1.E-25
          DB(J)=20.*ALOG10(FM(J))
20     CONTINUE
       RETURN
       END
C-------------DIGITAL FILTER FREQ RESPONSE--------------------
       SUBROUTINE DFR(KK,B1,B2,A1,A2,FM,DB,PHASE,DELAY,G,KFLAG,W0)
        DOUBLE PRECISION G
       DIMENSION B1(1),B2(1),A1(1),A2(1)
       DIMENSION FM(1),DB(1),PHASE(1),DELAY(1)
       COMMON /PARM/R1,R2,WP,WS,N2,N,SR,KA,KAD,KOD,KF
       COMMON /FLIMIT/FSTART,FSTOP
       TWOPI = 6.283185307179
C
        IF(KFLAG.EQ.1) THEN
           IF(KF.EQ.1) Q = 0
           IF(KF.EQ.2) Q = 3.14159265358
           IF(KF.EQ.3) Q = 2.*ATAN(W0/(2.*SR))
           IF(KF.EQ.4) Q = 0
           LL = 1
        ENDIF
        IF(KFLAG.EQ.2) THEN
           IF(KK.EQ.0) RETURN
           Q = TWOPI*FSTART/SR
           DQ = TWOPI*(FSTOP - FSTART)/(FLOAT(KK)*SR)
           LL = KK + 1
        ENDIF
       DO 20 J = 1, LL
          W  = Q + DQ*(J-1)
          IF(KFLAG.EQ.1) W=Q
          W2 = 2.0*W
          BR = 1.0
          BI = 0.0
          BDELAY = 0
          AR = 1.0
          AI = 0.0
          ADELAY = 0
          I0 = 1
          IF (KOD.EQ.0) GOTO 10
             BR = COS(W) + B1(1)
             BI = SIN(W)
             DBR = -SIN(W)
             DBI = COS(W)
             AR = COS(W) + A1(1)
             AI = SIN(W)
             DAR = -SIN(W)
             DAI = COS(W)
             BMAG2 = BR**2 + BI**2
             IF(BMAG2.EQ.0) BMAG2 = 1.E-25
             BDELAY = (BI*DBR - BR*DBI)/BMAG2
             AMAG2 = AR**2 + AI**2
             IF(AMAG2.EQ.0) AMAG2 = 1.E-25
             ADELAY = (AI*DAR - AR*DAI)/AMAG2
             I0 = 2
 10       DO 15 I = I0, N2
             BRT = COS(W2) + B1(I)*COS(W) + B2(I)
             BIT = SIN(W2) + B1(I)*SIN(W)
             DBRT = -2.*SIN(W2) - B1(I)*SIN(W)
             DBIT =  2.*COS(W2) + B1(I)*COS(W)
             ART = COS(W2) + A1(I)*COS(W) + A2(I)
             AIT = SIN(W2) + A1(I)*SIN(W)
             DART = -2.*SIN(W2) - A1(I)*SIN(W)
             DAIT =  2.*COS(W2) + A1(I)*COS(W)
             BMAG2 = BRT**2 + BIT**2
             IF(BMAG2.EQ.0) BMAG2 = 1.E-25
             BDELAY = BDELAY + (BIT*DBRT - BRT*DBIT)/BMAG2
             AMAG2 = ART**2 + AIT**2
             IF(AMAG2.EQ.0) AMAG2 = 1.E-25
             ADELAY = ADELAY + (AIT*DART - ART*DAIT)/AMAG2
             BRS = BR*BRT - BI*BIT
             BI  = BR*BIT + BI*BRT
             BR  = BRS
             ARS = AR*ART - AI*AIT
             AI  = AR*AIT + AI*ART
             AR  = ARS
 15       CONTINUE
          FM(J) = SQRT((BR*BR + BI*BI)/(AR*AR + AI*AI))
          IF(KFLAG.EQ.1) G = 1./FM(1)
          IF(KFLAG.EQ.2) THEN
             FM(J) = G*FM(J)
             DENOM = AR*BR + AI*BI
             IF(ABS(DENOM).LT.1.E-25) THEN
                TDENOM = DENOM
                DENOM = 1.E-25
                IF(TDENOM.LT.0) DENOM = - DENOM
             ENDIF
             FNUMER = AR*BI - AI*BR
             PHASE(J) = ATAN2(FNUMER,DENOM)
             DELAY(J) = (BDELAY - ADELAY)/SR
          ENDIF
          IF(FM(J).LT.1.E-25) FM(J) = 1.E-25
          DB(J)=20.*ALOG10(FM(J))
20    CONTINUE
       RETURN
       END
C-----------OUTPUT FREQUENCY RESPONSE------------------
       SUBROUTINE VIEW(SR,KK,FM,DB,PHASE,DELAY,FREQ)
       DIMENSION FM(1),DB(1),PHASE(1),DELAY(1),FREQ(1)
       COMMON /FLIMIT/FSTART,FSTOP
        CHARACTER YN
       F0 = (FSTOP - FSTART)/FLOAT(KK)
       WRITE(1,*) ' '
       WRITE(1,*) ' '
       WRITE(1,*) '                  FREQUENCY RESPONSE'
       WRITE(1,*) ' '
       WRITE(1,*) '     FREQUENCY      GAIN        GAIN (dB)      PHASE
     1     DELAY (SEC)'
       WRITE(1,*) ' '
       DO 10 J = 1, KK+1
          F = F0*(J-1) + FSTART
          FREQ(J) = F
          WRITE (1,100) FREQ(J), FM(J),DB(J),PHASE(J),DELAY(J)
 10    CONTINUE
 100   FORMAT(1X,F15.4,2X,1PE11.4,2X,1PE11.4,2X,0PF10.5,2X,E11.5)
        WRITE(*,*) ' '
        WRITE(*,'(1X,A,\)') 'CREATE  FREQ, LINEAR GAIN FILE (Y,N)? '
        READ(*,'(A)') YN
        IF(YN.EQ.'Y'.OR.YN.EQ.'y') THEN
          CALL GETFIL(2)
          WRITE(2,'(1X,F15.4,2X,E11.5)') (FREQ(J),FM(J),J=1,KK+1)
          CLOSE(2)
        ENDIF
        WRITE(*,'(1X,A,\)') 'CREATE  FREQ, DB GAIN FILE (Y,N)? '
        READ(*,'(A)') YN
        IF(YN.EQ.'Y'.OR.YN.EQ.'y') THEN
          CALL GETFIL(2)
          WRITE(2,'(1X,F15.4,2X,E11.5)') (FREQ(J),DB(J),J=1,KK+1)
          CLOSE(2)
        ENDIF
        WRITE(*,'(1X,A,\)') 'CREATE  FREQ, PHASE FILE (Y,N)? '
        READ(*,'(A)') YN
        IF(YN.EQ.'Y'.OR.YN.EQ.'y') THEN
          CALL GETFIL(2)
          WRITE(2,'(1X,F15.4,2X,E11.5)') (FREQ(J),PHASE(J),J=1,KK+1)
          CLOSE(2)
        ENDIF
        WRITE(*,'(1X,A,\)') 'CREATE  FREQ, DELAY FILE (Y,N)? '
        READ(*,'(A)') YN
        IF(YN.EQ.'Y'.OR.YN.EQ.'y') THEN
          CALL GETFIL(2)
          WRITE(2,'(1X,F15.4,2X,E11.5)') (FREQ(J),DELAY(J),J=1,KK+1)
          CLOSE(2)
        ENDIF
        RETURN
        END
C
        SUBROUTINE GETFIL(KUNIT)
        LOGICAL IXST
        CHARACTER FNAME*40
 101        WRITE(*,'(1X,A,\)') 'ENTER FILENAME: '
           READ(*,'(A)') FNAME
          INQUIRE(FILE=FNAME,EXIST=IXST)
           IF(IXST) THEN
             WRITE(*,*) CHAR(7)
             WRITE(*,*) ' **FILE ALREADY EXISTS. USE ANOTHER NAME.'
             WRITE(*,*) ' '
             GOTO 101
           ENDIF
        OPEN(KUNIT,FILE=FNAME,STATUS='NEW')
        RETURN
        END

